image: mcr.microsoft.com/dotnet/sdk:5.0-buster-slim-amd64

stages:
  - building
  - testing
  - publishing

before_script:
  - dotnet nuget add source
    "${CI_API_V4_URL}/groups/11737127/-/packages/nuget/index.json"
    --name gitlab-all
    --username gitlab-ci-token
    --password $CI_JOB_TOKEN
    --store-password-in-clear-text
  - if [ -z "$CI_COMMIT_TAG" ]; then
    export PROJECT_VERSION="0.1.$CI_PIPELINE_IID";
    echo "No tag provided. Version is set to $PROJECT_VERSION.";
    else
    export PROJECT_VERSION=$CI_COMMIT_TAG;
    fi

build:
  stage: building
  script:
    - dotnet build --configuration Release /p:Version=${PROJECT_VERSION} /p:PackageVersion=${PROJECT_VERSION}
  artifacts:
    paths:
      - build/bin/Release/*.nupkg
    expire_in: 5 mins

test:
  stage: testing
  script:
    - dotnet test --configuration Release /p:Version=${PROJECT_VERSION}

sast:
  stage: testing
include:
- template: Security/SAST.gitlab-ci.yml

publish:
  stage: publishing
  script:
    - dotnet nuget add source
      "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/nuget/index.json"
      --name gitlab
      --username gitlab-ci-token
      --password $CI_JOB_TOKEN
      --store-password-in-clear-text
    - dotnet nuget push "build/bin/Release/*.nupkg" --source gitlab
